var highlighterBar;
var eventWindowH;
var eventWindowW;
var eventWindowHours;

$(document).ready(function() {

  // $('#calendar').fullCalendar({
  //   header: {
  //     left: 'prev,next today',
  //     center: 'title',
  //     right: 'month,agendaWeek,agendaDay,listWeek'
  //   },
  //   defaultDate: Date(),
  //   navLinks: true, // can click day/week names to navigate views
  //   weekNumbers: true,
  //   weekNumbersWithinDays: true,
  //   weekNumberCalculation: 'ISO',
  //   editable: true,
  //   allDay: true,
  //   events:[ {
  //   title: 'Default Event',
  //       start: '2018-08-07',
  //       end: '2018-08-10'
  //   }],
  //   eventLimit: true, // allow "more" link when too many events
  //   eventDrop: function(event, delta, revertFunc) {
  //     $(formField().DTSTART).val(event.start.format());
  //   }
  // });

  var initialLocaleCode = 'en';
  var now = new Date().setMinutes(0);

  $(formField().DTSTART).datetimepicker();
  $(formField().DTEND).datetimepicker();

  $('#fullcalendar_scheduler').fullCalendar({
    schedulerLicenseKey: 'CC-Attribution-NonCommercial-NoDerivatives',
    now: now,
    editable: true, // enable draggable events
    aspectRatio: 1.8,
    scrollTime: '00:00', // undo default 6am scrollTime
    header: {
      left: 'promptTrainer promptRoom today prev,next',
      center: 'title',
      right: 'timeline1Day,timeline2Days,timeline3Days,timeline4Days,timeline5Days,timeline7Days'
    },
    customButtons: {
      promptTrainer: {
        text: '+ trainer',
        click: function() {
          var title = prompt('Trainer name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      },
      promptRoom: {
        text: '+ room',
        click: function() {
          var title = prompt('Room name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      }
    },
    defaultView: 'timeline1Day',
    views: {
      timeline1Day: {
        type: 'timeline',
        duration: { days: 1 },
        //buttonText: '1 day'
      },
      timeline2Days: {
        type: 'timeline',
        duration: { days: 2 }
      },
      timeline3Days: {
        type: 'timeline',
        duration: { days: 3 }
      },
      timeline4Days: {
        type: 'timeline',
        duration: { days: 4 }
      },
      timeline5Days: {
        type: 'timeline',
        duration: { days: 5 }
      },
      timeline7Days: {
        type: 'timeline',
        duration: { weeks: 1 },
        //buttonText: '1 week'
      },
    },

    resourceGroupField: 'resourceType',
    //resourceLabelText: 'Rooms',
    resources: [
      { id: 'a', resourceType: 'Trainer', title: 'Trainer 1' },
      { id: 'b', resourceType: 'Trainer', title: 'Trainer 2' },
      { id: 'c', resourceType: 'Trainer', title: 'Trainer 3' },
      { id: 'd', resourceType: 'Trainer', title: 'Trainer 4' },
      { id: 'e', resourceType: 'Room', title: 'Room 1' },
      { id: 'f', resourceType: 'Room', title: 'Room 2' },
      { id: 'g', resourceType: 'Room', title: 'Room 3' },
      { id: 'h', resourceType: 'Room', title: 'Room 4' },
      { id: 'i', resourceType: 'Equipment', title: 'Equipment 1' },
      { id: 'j', resourceType: 'Equipment', title: 'Equipment 2' }
    ],

    events: [
      { id: '1', resourceIds: ['b', 'e'], start: dateAdd(now, 'minute', 30), end: dateAdd(now, 'minute', 120), title: 'event 1' },
      { id: '2', resourceId: 'c', start: dateAdd(now, 'hour', -3), end: dateAdd(now, 'hour', -1), title: 'event 2' },
      { id: '3', resourceId: 'd', start: dateAdd(now, 'hour', -2), end: dateAdd(now, 'hour', 0), title: 'event 3' },
      { id: '4', resourceId: 'e', start: dateAdd(now, 'hour', -1), end: dateAdd(now, 'minute', -30), title: 'event 4' },
      { id: '5', resourceId: 'f', start: dateAdd(now, 'hour', 1), end: dateAdd(now, 'hour', 2), title: 'event 5' }
    ],

    // Callbacks
    viewRender: function(view, element) {
    },

    eventAfterAllRender: function (view) {
      switch(view.name) {
        case 'timeline1Day':
          eventWindowHours = 24;
          break;
        case 'timeline2Days':
          eventWindowHours = 24 * 2;
          break;
        case 'timeline3Days':
          eventWindowHours = 24 * 3;
          break;
        case 'timeline4Days':
          eventWindowHours = 24 * 4;
          break;
        case 'timeline5Days':
          eventWindowHours = 24 * 5;
          break;
        case 'timeline7Days':
          eventWindowHours = 24 * 7;
          break;
        default:
          eventWindowHours = 24;
      }

      renderHighlighterBar(now, dateAdd(now, 'minute', 30));
    },
  });

  // build the locale selector's options
  $.each($.fullCalendar.locales, function(localeCode) {
    $('#locale-selector').append(
      $('<option/>')
        .attr('value', localeCode)
        .prop('selected', localeCode == initialLocaleCode)
        .text(localeCode)
    );
  });

  // when the selected option changes, dynamically change the calendar option
  $('#locale-selector').on('change', function() {
    if (this.value) {
      //$.datetimepicker.setLocale(this.value);
      //$('#fullcalendar_scheduler').fullCalendar('option', 'locale', this.value);
      setLocaleCode(this.value);
      renderHighlighterBar(now, dateAdd(now, 'minute', 30));
    }
  });

  setLocaleCode(initialLocaleCode);
  renderHighlighterBar(now, dateAdd(now, 'minute', 30));

});

function setLocaleCode(localeCode) {
  $.datetimepicker.setLocale(localeCode);
  $('#fullcalendar_scheduler').fullCalendar('option', 'locale', localeCode);
}

function onHighlighterBarUpdate(event, ui, obj) {
  console.log("======== func ==========");
    console.log("event: " + event);
    console.log("ui: " + ui);
    console.log("$(this): " + $(this));
  var startTime = eventWindowHours * ui.position.left / eventWindowW.width();
  var eventDuration = eventWindowHours * obj.width() / eventWindowW.width();
  var endTime = startTime + eventDuration;

  var displayDate = $('#fullcalendar_scheduler').fullCalendar('getDate');
  var isRTL = $('#calendar').fullCalendar('option', 'isRTL');
  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  var viewStartDate = new Date(view.intervalStart.toDate());
  var viewEndDate = new Date(view.intervalEnd.toDate());
  //view.slotDuration
  //view.slotWidth
  //view.slotCnt

  var startDate = dateAdd(viewStartDate, 'day', parseInt(startTime/24));
  var endDate = dateAdd(viewStartDate, 'day', parseInt(endTime/24));

  startDate.setHours( Math.floor(startTime) );
  startDate.setMinutes( 60 * (startTime % 1).toFixed(10) );
  endDate.setHours( Math.floor(endTime) );
  endDate.setMinutes( 60 * (endTime % 1).toFixed(10) );
  // setDate()	Sets the day of the month of a date object
  // setFullYear()	Sets the year of a date object
  // setHours()	Sets the hour of a date object
  // setMilliseconds()	Sets the milliseconds of a date object
  // setMinutes()	Set the minutes of a date object
  // setMonth()	Sets the month of a date object


  $(formField().DTSTART).val( formatDate(startDate) );
  $(formField().DTEND).val( formatDate(endDate) );

  $(formField().DURATION).val(parseInt(eventDuration * 60));
  $("#resource_planner_event_duration").val(parseInt(eventDuration * 60));
}

function formatDate(date) {
  var d = date;
  var date_format_str = d.getFullYear().toString()+"-"+((d.getMonth()+1).toString().length==2?(d.getMonth()+1).toString():"0"+(d.getMonth()+1).toString())+"-"+(d.getDate().toString().length==2?d.getDate().toString():"0"+d.getDate().toString())+" "+(d.getHours().toString().length==2?d.getHours().toString():"0"+d.getHours().toString())+":"+((parseInt(d.getMinutes()/5)*5).toString().length==2?(d.getMinutes()).toString():"0"+(d.getMinutes()).toString())+":00";
  return date_format_str;
}

function renderHighlighterBar(start_date, end_date) {
  //debugger;
  highlighterBar = $('#highlighter');
  if( highlighterBar.length == 0 ) {
    $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller div.fc-scroller-canvas').prepend($('<div id="highlighter" draggable="true"></div>'));
    highlighterBar = $('#highlighter');
  }

  eventWindowH = $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller');
  eventWindowW = $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller-canvas');

  var isRTL = $('#calendar').fullCalendar('option', 'isRTL');
  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  var viewStartDate = new Date(view.intervalStart.toDate());
  var viewEndDate = new Date(view.intervalEnd.toDate());

  highlighterBar.height( eventWindowH.height() );
  highlighterBar.draggable({ axis: "x" });
  highlighterBar.resizable({ handles: "e, w" });

  var startDate = $.trim($(formField().DTSTART).val());
  var endDate = $.trim($(formField().DTEND).val());
  var duration = $.trim($(formField().DURATION).val());

  if( endDate || duration) {
    var left = new Date(startDate).getTime() * eventWindowW.width() / eventWindowHours;
    if(endDate) {
      var width = (new Date(endDate).getTime() * eventWindowW.width() / eventWindowHours) - left;
    }
    if(duration) {
      var width = duration * eventWindowW.width() / eventWindowHours;
    }
  }

  highlighterBar.on('drag', function( event, ui ) {
    onHighlighterBarUpdate(event, ui, $(this));
  });

  highlighterBar.on('resize', function( event, ui ) {
    console.log("======== Resize ==========");
    console.log("event: " + event);
    console.log("ui: " + ui);
    console.log("$(this): " + $(this));
    onHighlighterBarUpdate(event, ui, $(this));
  });
}
