//
// FullcalendarTimeline - Tool-tip and Zoom handlers
//

// Initialise i18n controls/data
FullcalendarTimeline.prototype.initialiseHighlighterbarTooltip = function () {
	// Mechanism to pass (this) to the handlers
	var fullCalendarTimelineObject = this;

	this._timelineViewWrapper.find('tbody.fc-body td.fc-time-area.fc-widget-content div.fc-scroller-clip  div.fc-scroller div.fc-scroller-canvas').prepend($('<span id="highlighter-tooltip" class="highlighter-tooltip">our tooltip</span>'));
	//$('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller div.fc-scroller-canvas').prepend($('<span id="highlighter-tooltip" class="highlighter-tooltip">our tooltip</span>'));
	this._tooltip = this._timelineViewWrapper.find('#highlighter-tooltip');

	window.onmousemove = function (e) {
		var tooltipSpan = fullCalendarTimelineObject._tooltip;
		var x = e.clientX,
			y = e.clientY;

		if (tooltipSpan) {
			tooltipSpan[0].style.position = 'fixed';
			tooltipSpan[0].style.top = y - 50 + 'px';
			if (e.clientX > 550) {
				tooltipSpan[0].style.left = x - 130 + 'px';
			} else {
				tooltipSpan[0].style.left = x + 20 + 'px';
			}
		}
	};
}

FullcalendarTimeline.prototype.showTooltip = function (event, ui, obj) {
	var id = obj.attr('id');
	var eventIndex = id.split('-')[1];
	var startDate = formatDate(new Date(this._eventUnits[eventIndex].startDate));
	var eventDuration = this._eventUnits[eventIndex].eventDuration;
	var durationUnits = this._eventUnits[eventIndex].durationUnits;
	//var endDate = formatDate(new Date(this._eventUnits[eventIndex].endDate));
	var begin_date = moment(startDate).format('LLLL');
	var day_of_week_name = begin_date.substr(0, begin_date.indexOf(','))

	var tooltipText =
		'<small>Start: </small>' + startDate + '<br/>' +
		'<small>Duration: </small>' + eventDuration + ' ' + durationUnits + '(s)' + '<br/>' +
		'<small>' + day_of_week_name + '<br/>';

	if (!this._zoomed) {
		this._tooltip.html(tooltipText + 'double click to zoom in!');
		//this._tooltip.html(tooltipText + '<em>double click to zoom in!</em>');
	} else {
		this._tooltip.html(tooltipText + 'double click to zoom out!');
	}

	this._tooltip.css('visibility', 'visible');
}

FullcalendarTimeline.prototype.hideTooltip = function (event, ui, obj) {
	this._tooltip.css('visibility', 'hidden');
}

FullcalendarTimeline.prototype.dblclickEventZoomIn = function (event, ui, obj) {
	var startDate, endDate;

	if (!this._zoomed) {
		// zoom in
		var id = obj.attr('id');
		var eventIndex = id.split('-')[1];
		startDate = formatDate(new Date(this._eventUnits[eventIndex].startDate));
		endDate = formatDate(new Date(this._eventUnits[eventIndex].endDate));
	} else {
		// zoom out
		startDate = formatDate(new Date(this._eventUnits[0].startDate));
		endDate = formatDate(new Date(this._eventUnits[this._eventUnits.length - 1].endDate));
	}

	this.updateTimelineDuration(startDate, endDate);
	this._zoomed = !this._zoomed;
}
