module ResourcePlanner
  #class ApplicationController < ActionController::Base
  class ApplicationController < ::ApplicationController

    protect_from_forgery with: :exception

    before_action :get_uri_info
    before_action :set_timezone

    helper_method :mounted_path
    helper_method :get_resource_models

    def get_uri_info
      @mounted_path = ::ResourcePlanner.mounted_path
      #puts "**************: ResourcePlanner.mounted_path = '" + @mounted_path + "'"
    end

    def mounted_path
      @mounted_path
    end

    protected

    def back_url
      params[:back_url] || request.env['HTTP_REFERER'] || root_url
    end

    private

    def get_application_preferences
      ::ResourcePlanner.application_preferences
    end

    def get_resource_models
      if !@current_resource_model_group.present? || !@current_resource_model_group.eql?('null')
        resource_model_groups_hash = get_resource_model_groups.reduce Hash.new, :merge
        ::ResourcePlanner.resource_models unless (resource_model_groups_hash.key?(@current_resource_model_group) ||
                                                  resource_model_groups_hash.key?(@current_resource_model_group.to_sym))

        resource_models = []
        resource_model_groups_hash[@current_resource_model_group].each do |model_reference|
          resource_model = ::ResourcePlanner.resource_models.select {|resource_model| resource_model[:model_reference].to_sym == model_reference.to_sym}
          resource_models << resource_model[0] unless resource_model.empty?
        end
        resource_models
      else
        ::ResourcePlanner.resource_models
      end
    end

    def get_resource_model_groups
      ::ResourcePlanner.resource_model_groups
    end

    def set_timezone
      Time.zone = cookies['time_zone']
    end

  end
end
