require_dependency "resource_planner/application_controller"

module ResourcePlanner
  class ApplicationPreferencesController < ApplicationController
    # GET /resource_planner/application_preferences/all
    # GET /resource_planner/application_preferences/all.json
    def all
      @application_preferences = {}

      # Initialise all default user preferences, in event that they are not overridden in the 'application_preferences' structure
      @application_preferences[:locale] = 'en'; # e.g. 'en-gb' (navigator.languages might be better)
      @application_preferences[:timezone] = Time.zone.name
      @application_preferences[:first_day_of_the_week] = 'Sunday'
      @application_preferences[:highlighter_bar_colour] = 'Green'
      @application_preferences[:conflict_colour] = 'IndianRed'
      @application_preferences[:conflict_timeline_colour] = 'LightSalmon'
      @application_preferences[:selected_resource_colour] = 'LightSeaGreen'
      @application_preferences[:selected_resource_timeline_colour] = 'rgba(0, 0, 0, 0)'
      @application_preferences[:resource_available_colour] = 'White'
      @application_preferences[:resource_unavailable_colour] = 'Gray'

      # Override defaults with values from the 'application'
      get_application_preferences.each do |user_preference|
        data_query = user_preference[:data_query]
        unless data_query.nil? || data_query.empty?
          user_preference_value = eval(data_query)
          @application_preferences[user_preference[:key]] = user_preference_value
        end
      end

      respond_to do |format|
        format.html # application_preferences.html.erb
        #format.html { render 'application_preferences.html.erb' }
        format.xml  { render :xml => @application_preferences }
        # TODO: DEPRECATION WARNING: Rendering actions with '.' in the name is deprecated:
        #       resource_planner/resources/restrictions.json.jbuilder (called from block
        #       (2 levels) in restrictions at
        #       /home/projects/everard/webprojects/git/rails_engines/resource_planner/app/controllers/resource_planner/resources_controller.rb:57)
        #
        # The following line is supposed to fix this deprecation, but it doesn't work:
        # format.json { render partial: 'application_preferences', formats: [:json], handlers: [:builder, :jbuilder] }
        format.json { render 'application_preferences.json.jbuilder' }
        #format.json { render :json => @application_preferences }
      end
    end
  end
end
