require_dependency 'resource_planner/application_controller'

module ResourcePlanner
  class EventUnitsController < ApplicationController
    before_action :set_event_unit, only: [:show, :edit, :update, :destroy]

    # GET /event_units
    def index
      @event_units = ::ResourcePlanner::EventUnit.all

      respond_to do |format|
        #format.html # index.html.erb
        format.xml  { render :xml => @event_units }
        format.json # index.json.jbuilder
        #format.json { render ('index.json.jbuilder') }
        #format.json { render :json => @event_units }
      end
    end

    # GET /event_units/1
    def show
      respond_to do |format|
        #format.html # show.html.erb
        #format.html { render ('show.' + ( params[:view].nil? ? '' : "#{params[:view]}." ) + 'html.erb') }
        format.xml  { render :xml => @event_unit }
        format.json { render :json => @event_unit }
      end
    end

    # GET /event_units/new
    def new
      @event_unit = ::ResourcePlanner::EventUnit.new
    end

    # GET /event_units/1/edit
    def edit
    end

    # POST /event_units
    def create
        @event_unit = ::ResourcePlanner::EventUnit.new(event_unit_params)

      respond_to do |format|
        if @event_unit.save
          #format.html { redirect_to @event_unit, notice: 'EventUnit was successfully created.' }
          format.xml  { render :xml => @event_unit, :status => :created, :location => @event_unit }
          format.json { render :json => @event_unit, :status => :created, :location => @event_unit }
          #format.xml  { head :ok }
          #format.json { head :no_content }
        else
          #format.html { render :new }
          format.xml  { render :xml => @event_unit.errors, :status => :unprocessable_entity }
          format.json { render :json => @event_unit.errors, :status => :unprocessable_entity }
        end
      end
    end

    # PATCH/PUT /event_units/1
    def update
      if @event_unit.update(event_unit_params)
        #format.html { redirect_to @event_unit, notice: 'EventUnit was successfully updated.' }
        format.xml  { head :ok }
        format.json { head :no_content }
      else
        #format.html { render :edit }
        format.xml  { render :xml => @event_unit.errors, :status => :unprocessable_entity }
        format.json { render :json => @event_unit.errors, :status => :unprocessable_entity }
      end
    end

    # DELETE /event_units/1
    def destroy
      @event_unit.destroy

      respond_to do |format|
        #format.html { redirect_to event_units_url, notice: 'EventUnit was successfully destroyed.' }
        format.xml  { head :ok }
        format.json { head :no_content }
      end
    end

    # GET /event_units/events
    def events
      @event_units = ::ResourcePlanner::EventUnit.events

      respond_to do |format|
        #format.html # index.html.erb
        format.xml  { render :xml => @event_units }
        format.json # index.json.jbuilder
        #format.json { render ('index.json.jbuilder') }
        #format.json { render :json => @event_units }
      end
    end

    # GET /event_units/resource_availabilities
    def resource_availabilities
      @event_units = ::ResourcePlanner::EventUnit.resource_availabilities

      respond_to do |format|
        #format.html # index.html.erb
        format.xml  { render :xml => @event_units }
        format.json # index.json.jbuilder
        #format.json { render ('index.json.jbuilder') }
        #format.json { render :json => @event_units }
      end
    end

    # GET /event_units/resource_restrictions
    def resource_restrictions
      @event_units = ::ResourcePlanner::EventUnit.resource_restrictions

      respond_to do |format|
        #format.html # index.html.erb
        format.xml  { render :xml => @event_units }
        format.json # index.json.jbuilder
        #format.json { render ('index.json.jbuilder') }
        #format.json { render :json => @event_units }
      end
    end

    private
      # Use callbacks to share common setup or constraints between actions.
      def set_event_unit
        @event_unit = ::ResourcePlanner::EventUnit.find(params[:id])
      end

      # Only allow a trusted parameter "white list" through.
      def event_unit_params
        params.fetch(:event_unit, {})
      end

  end
end
