require_dependency 'resource_planner/application_controller'

module ResourcePlanner
  class ResourcesController < ApplicationController
    before_action :handle_cookies, except: [:set_current_resource_model_group]

    # GET /resource_planner/list.json
    def list
      @resources = {}
      @resource_models = get_resource_models
      @resource_models.each do |resource_model|
        resource_model_data = if resource_model[:data_query].nil? || resource_model[:data_query].empty?
                          resource_model[:model].constantize.all
                        else
                          eval(resource_model[:data_query])
                        end

        @resources[resource_model] = resource_model_data
      end

      respond_to do |format|
        format.html # list.html.erb
        #format.html { render ('list.html.erb') }
        format.xml  { render :xml => @resources }
        format.json { render 'list.json.jbuilder' }
        #format.json { render :json => @resources }
      end
    end

    # GET /resource_planner/events.json
    # GET /resource_events.json
    def events
      @resource_models = get_resource_models
      @application_preferences = get_application_preferences
      @events = ::ResourcePlanner::Event.events

      respond_to do |format|
        format.html # events.html.erb
        #format.html { render ('events.html.erb') }
        format.xml  { render :xml => @events }
        format.json { render 'events.json.jbuilder' }
        #format.json { render :json => @events }
      end
    end

    # GET /resource_planner/restrictions.json
    # GET /resource_restrictions.json
    def restrictions
      @resource_models = get_resource_models
      @application_preferences = get_application_preferences
      @events = ::ResourcePlanner::Event.resource_restrictions

      respond_to do |format|
        format.html # events.html.erb
        #format.html { render ('restrictions.html.erb') }
        format.xml  { render :xml => @events }
        format.json { render 'restrictions.json.jbuilder' }
        #format.json { render :json => @events }
      end
    end

    # POST /resource_model_group
    def set_current_resource_model_group
      proposed_name = params[:name]
      resource_model_groups_hash = get_resource_model_groups.reduce Hash.new, :merge
      if (resource_model_groups_hash.key?(proposed_name) || resource_model_groups_hash.key?(proposed_name.to_sym))
        @current_resource_model_group = cookies[:current_resource_model_group] = proposed_name
      end

      if @current_resource_model_group == proposed_name
        format.xml  { head :ok }
        format.json { head :no_content }
      else
        format.xml  { render :xml => 'Request not accepted', :status => :unprocessable_entity }
        format.json { render :json => 'Request not accepted', :status => :unprocessable_entity }
      end
    end

    private

    def handle_cookies
      @current_resource_model_group = cookies[:current_resource_model_group]
      # Do whatever it is you want to do with your cookies
    end

  end
end
