# frozen_string_literal: true
module ResourcePlanner
  class AvailabiltyDateDefinition < ApplicationRecord

    belongs_to :resource, :polymorphic => true
    belongs_to :availabilty_date, :class_name => '::ResourcePlanner::Event'

    #--------------------------------------------------------------------------

    #attr_accessible :name
    #attr_accessible :resource, :resource_id, :resource_type
    #attr_accessible :availabilty_date, :availabilty_date_id

    #--------------------------------------------------------------------------

    validates :resource, :presence => true
    validates :availabilty_date, :presence => true

    #----------------------------------------------------------------------------

    # Handlers for polymorphic values (using Global ID)

    # Use :to_global_id to populate forms
    def resource_gid
      resource&.to_global_id
    end

    # Set the attribute from a Global ID (handles the form submission)
    def resource_gid=(gid)
      self.resource = GlobalID::Locator.locate gid
    end

    #--------------------------------------------------------------------------

    def to_s
      ((name.nil? || name.empty?) ? '' : "#{name} - ") + "#{resource} - #{availabilty_date}"
    end

    #--------------------------------------------------------------------------

    private

  end
end
