module ResourcePlanner
  class EventType < ApplicationRecord

    has_many :events, :class_name => '::ResourcePlanner::Event'

    #---------- Scopes

    scope :event, -> { where(:name => 'EVENT').first }
    scope :availability, -> { where(:name => 'AVAILABILITY').first }
    scope :restriction, -> { where(:name => 'RESTRICTION').first }

    #--------------------------------------------------------------------------

    validates :name, :presence => true

    #--------------------------------------------------------------------------

    def to_s
      "#{name}"
    end

  end
end
