module ResourcePlanner
  class EventUnitSubscription < ApplicationRecord

    belongs_to :event_unit, class_name: '::ResourcePlanner::EventUnit', inverse_of: :subscriptions
    belongs_to :resource, polymorphic: true

    #--------------------------------------------------------------------------

    #attr_accessible :event_unit, :event_unit_id
    #attr_accessible :resource, :resource_id, :resource_type

    #attr_accessible :ambit
    #attr_accessible :quantity

    #attr_accessible :name, :notes

    #--------------------------------------------------------------------------

    validates :event_unit, :presence => true
    validates :resource, :presence => true
    # validates :quantity

    # TODO: (2)
    # 1) validate quantity assigned is <= available quantity of the 'resource'
    # OR
    # 2) allow overallocation and provide detection of additional requirements

    #----------------------------------------------------------------------------

    # Handlers for polymorphic values (using Global ID)

    # Use :to_global_id to populate forms
    def resource_gid
      resource&.to_global_id
    end

    # Set the attribute from a Global ID (handles the form submission)
    def resource_gid=(gid)
      self.resource = GlobalID::Locator.locate gid
    end

    #--------------------------------------------------------------------------

    def to_s
      ((name.nil? || name.empty?) ? '' : "#{event_unit.name} - ") + "#{event_unit} - #{resource} - #{quantity}"
    end

    #--------------------------------------------------------------------------

    private

  end
end
