get_resource_models.each do |resource_model|

  json.array!(@resources[resource_model]) do |resource|

    json.extract! resource, :id
    # json.id "#{resource_model[:model_reference]}-#{resource_model[:model]}-#{resource.id}-#{resource.quantity}"
    json.id "#{resource_model[:model]}-#{resource.id}-#{resource.quantity}"
    json.title resource.to_s
    json.quantity resource.quantity

    # resourceType is used for grouping, in the resource list
    resource_group_name = if !(resource_model[:resource_group_name].nil? || resource_model[:resource_group_name].empty?)
                            resource_model[:resource_group_name]
                          elsif !(resource_model[:resource_group_name_attribute].nil? || resource_model[:resource_group_name_attribute].empty?)
                            eval("resource.#{resource_model[:resource_group_name_attribute]}")
                          else
                            resource_model[:model].split(':').last
                          end

    json.resourceModelReference "#{resource_model[:model_reference]}"
    json.resourceType "#{resource_group_name.pluralize}"

    # json.eventColor
    # json.eventBackgroundColor
    # json.eventBorderColor
    # json.eventTextColor
    # json.eventClassName
    # json.businessHours # availability
    # json.children
    # json.parentId
    # json.parent


    # fullcalendar - resource object documentation
    # --------------------------------------------
    # id	Uniquely identifies this resource. Event Objects with a corresponding resourceId field will be linked to this event. Will be coerced into a string.
    # eventColor	Events associated with this resources will have their backgrounds and borders colored. Any CSS string color format can be specified, like "#f00" or "rgb(255,0,0)". This value will take precedence over the global eventColor option and the Event Source Object color option, but it will not take precedence over the Event Object color option.
    # eventBackgroundColor	Like eventColor but only for the background color
    # eventBorderColor	Like eventColor but only for the border color
    # eventTextColor	Like eventColor but only for the text color
    # eventClassName	className(s) that will apply to events
    # businessHours	A businessHours declaration that will only apply to this resource. See example.
    # children	See below
    # parentId	See below
    # parent	See below
    #
    # The parent and children properties
    # Regardless of which method is used to set the parent/child relationship, the resulting Resource Objects throughout the API will still get the parent and children properties assigned.
    # parent is a reference to the parent Resource Object. It will be null if there is no parent.
    # children is an array of child Resource Objects.

  end
end
