module ResourcePlanner
  # Returns the version of the currently loaded gem as a <tt>Gem::Version</tt>
  def self.gem_version
    Gem::Version.new VERSION::STRING
  end

  def self.version
    VERSION::STRING.to_f
  end

  module VERSION
    MAJOR = 0
    MINOR = 5
    PATCH = 'alpha'
    PRE   = 10

    STRING = [MAJOR, MINOR, PATCH, PRE].compact.join(".")
  end
end
