# frozen_string_literal: true

$LOAD_PATH.push File.expand_path('lib', __dir__)

# Maintain your gem's version:
require 'resource_planner/version'

# Describe your gem and declare its dependencies:
Gem::Specification.new do |s|
  s.name          = 'resource_planner'
  s.version       = ResourcePlanner::VERSION::STRING.dup
  s.authors       = ['Everard Brown']
  s.email         = ['Everard.Brown@htcl.eu']
  s.homepage      = 'http://htcl.eu'
  s.summary       = "ResourcePlanner engine (v#{s.version})"
  s.description   = 'Resource calendar management'
  s.license       = 'COPYRIGHT'

  s.files         = Dir["#{s.name}.gemspec", '{app,config,db,lib}/**/*', 'LICENSE', 'README.md']
  s.require_paths = ['lib']

  s.rdoc_options     = ['--line-numbers', '--inline-source', '--title', 'resource_planner', '--main', 'README.md']
  s.extra_rdoc_files = ['lib/tasks/resource_planner_tasks.rake', 'lib/resource_planner.rb']

  s.add_dependency 'rails', '>= 5.0'

  s.add_dependency 'jquery-rails'
  s.add_dependency 'jquery-ui-rails'
  #s.add_dependency 'jquery-week-calendar'

  # TODO: Source this via yarn or webpack
  #       rails-assets.org is going offline
  #       See: https://github.com/xdan/datetimepicker
  s.add_dependency 'rails-assets-datetimepicker'

  s.add_dependency 'bootstrap', '~> 4.0'
  #s.add_dependency 'bootstrap4-datetime-picker-rails'

  # Build JSON APIs with ease. Read more: https://github.com/rails/jbuilder
  s.add_dependency 'jbuilder' #, '~> 1.2'

  # Browser timezone detection
  s.add_dependency 'browser-timezone-rails'

  # calendar
  s.add_dependency 'fullcalendar-rails', '~> 4.0'
  s.add_dependency 'moment_timezone-rails'
  s.add_dependency 'momentjs-rails'

  # iCal processor
  s.add_dependency 'icalendar'
  s.add_dependency 'ice_cube'

  # In-house gems
  # (during development, the dependency in Gemfile will be used)
  require File.join(File.dirname(__FILE__), 'config', 'in_house_gems')
  in_house_engines = RESOURCE_PLANNER_IN_HOUSE_ENGINES
  in_house_engines.each { |in_house_engine| s.add_dependency in_house_engine.to_s }
end
